#include <QtGui/QApplication>
#include "mainwindow.h"
#include <QDebug>

#include "videofile.h"
#include <cv.h>
#include <QVector>
#include <QVector3D>
#include <QString>
#include <QDebug>

void printMatrix(CvMat * L)
{
    int rows = L->rows;
    int cols = L->cols;

    QString output;
    output.append("[");
    for(int i = 0; i < rows; i++) {
        for(int j = 0; j < cols; j++) {
            QString num;
            num.setNum(cvGetReal2D(L, i, j));
            output.append(num);
            output.append("\t");
        }
        output.append(";\n");
    }
    output.append("]");
    qDebug() << output;
}

int main(int argc, char *argv[])
{

    /*QVector <QVector3D> initial;
    initial.append(QVector3D(-0.0466, -0.0429, 0.0284));
    initial.append(QVector3D(0.0336, 0.0262, -0.0368));
    initial.append(QVector3D(0.0130, 0.0166, 0.0084));

    QVector <QVector3D> current;
    current.append(QVector3D(-0.0468, -0.0420, 0.0276));
    current.append(QVector3D(0.0336, 0.0256, -0.0362));
    current.append(QVector3D(0.0131, 0.0164, 0.0086));


    int rows = initial.size() * 3;
    int cols = 9;

    CvMat * A = cvCreateMat(rows, cols, CV_32F);
    CvMat * B = cvCreateMat(rows, 1, CV_32F);

    cvZero(A);
    cvZero(B);

    for(int i = 0; i < initial.size(); i++) {

        // Row 1 per 3D point in A
        cvSetReal2D(A, i * 3 + 0, 0, initial.at(i).x());
        cvSetReal2D(A, i * 3 + 0, 1, initial.at(i).y());
        cvSetReal2D(A, i * 3 + 0, 2, initial.at(i).z());

        // Row 2 per 3D point in A
        cvSetReal2D(A, i * 3 + 1, 3, initial.at(i).x());
        cvSetReal2D(A, i * 3 + 1, 4, initial.at(i).y());
        cvSetReal2D(A, i * 3 + 1, 5, initial.at(i).z());

        // Row 3 per 3D point in A
        cvSetReal2D(A, i * 3 + 2, 6, initial.at(i).x());
        cvSetReal2D(A, i * 3 + 2, 7, initial.at(i).y());
        cvSetReal2D(A, i * 3 + 2, 8, initial.at(i).z());

        // Row 1, 2, 3 in B
        cvSetReal2D(B, i * 3 + 0, 0, current.at(i).x());
        cvSetReal2D(B, i * 3 + 1, 0, current.at(i).y());
        cvSetReal2D(B, i * 3 + 2, 0, current.at(i).z());
    }

    qDebug() << "A:";
    printMatrix(A);

    qDebug() << "B:";
    printMatrix(B);

    CvMat * r = cvCreateMat(9, 1, CV_32F);
    cvSolve(A, B, r, CV_SVD_SYM);

    qDebug() << "r:";
    printMatrix(r);

*/


    QApplication a(argc, argv);
    MainWindow w;
    w.show();
    a.exec();
    return 0;
}
