#ifndef MAPSELECTOR_H
#define MAPSELECTOR_H

#include <QWidget>

class Mapselector : public QWidget
{
    Q_OBJECT

public:
    Mapselector(QWidget *parent = 0);
    QSize sizeHint() const;
    void setSize(QSize size);

protected:
    void mousePressEvent(QMouseEvent * event);
    void mouseMoveEvent(QMouseEvent * event);
    void paintEvent(QPaintEvent * event);
    void resizeEvent(QResizeEvent * event);


private:
    QSize gridSize;
    int minSquareSize;
    QPoint selectedSquare;
    QRect gridRect();

signals:
    void squareSelected(QPoint);
};

#endif // MAPSELECTOR_H
