#ifndef HISTOGRAMDISPLAY_H
#define HISTOGRAMDISPLAY_H

#include <QGraphicsItemGroup>
#include <QGraphicsRectItem>
#include <vector>
#include <cv.h>

using namespace std;

class HistogramDisplay : public QGraphicsItemGroup
{
public:
    HistogramDisplay();
    void setRange(int, int, int);
    void setHistogram3D(CvHistogram *);
    virtual QRectF boundingRect() const;

private:
    vector<QGraphicsRectItem *> bars;
    int lowerLimit;
    int upperLimit;


};

#endif // HISTOGRAMDISPLAY_H
