#ifndef IMAGE_H
#define IMAGE_H

#include <QString>
#include "videosource.h"

class Image : public VideoSource
{
private:
   QString filename;
   IplImage * frameImage;

public:
    Image(QString);
    ~Image();
    bool init();
    IplImage * getFrame();
    bool captureFrame();
    void close();
    QSize getVideoSize();
};


#endif // IMAGE_H
