#ifndef PARAMETERS_H
#define PARAMETERS_H

#include <QWidget>
#include <QVector>

class Camera;

namespace Ui {
    class Parameters;
}

class Parameters : public QWidget {
    Q_OBJECT
public:
    Parameters(QWidget *parent = 0);
    ~Parameters();
    void setCameras(QVector <Camera *> cameras);

protected:
    void changeEvent(QEvent *e);

private:
    Ui::Parameters *ui;
    QVector <Camera *> cameras;

private slots:
    void on_cannyParam2Slider_valueChanged(int value);
    void on_cannyParam1Slider_valueChanged(int value);
    void on_houghThresholdSlider_valueChanged(int value);

    void trackingParamChanged();
};

#endif // PARAMETERS_H
