# -------------------------------------------------
# Project created by QtCreator 2009-10-02T19:56:58
# -------------------------------------------------
TARGET = shiptrack
TEMPLATE = app
win32 { 
    MATLABROOT = C:\Program \
        Files\MATLAB\R2009a
    LIBS += -L"C:\libs\OpenCV2.0\release\lib\Debug" \
        -lcv200d \
        -lcxcore200d \
        -lhighgui200d \
        -L"C:\libs\qwt-5.2\lib" \
        -llibqwtd5 \
        -L"C:\msys\1.0\local\lib" \
        -lavdevice \
        -lavformat \
        -lavcodec \
        -lavutil \
        -lswscale \
        -lWs2_32 \
        -L"C:\libs\glew-1.5.3\lib" \
        -lglew32 \
        -L"C:\Program Files\Microsoft SDKs\Windows\v6.0A\Lib" \
        -lglu32 \
        -lopengl32 \
        -L"$$MATLABROOT\extern\lib\win32\microsoft" \
        -llibmx \
        -llibmat
    INCLUDEPATH += C:\libs\OpenCV2.0\include\opencv \
        "C:\Documents and Settings\hornang\My Documents\qwt-5.2.0\src" \
        C:\msys\1.0\local\include \
        C:\libs\cmu1394\include \
        C:\libs\glew-1.5.3\include \
        "$$MATLABROOT\extern\include"
}
unix { 
    MATLABROOT = /home/hornang/matlab
    LIBS += -L/usr/local/lib \
        -lcv \
        -lcxcore \
        -lhighgui \
        -lavcodec \
        -lavdevice \
        -lavformat \
        -lavutil \
        -lswscale \
        -L/usr/local/qwt-5.2.1-svn/lib \
        -lqwt \
        -lGLEW \
        -L$$MATLABROOT/bin/glnx86 \
        -lmat \
        -Wl,-rpath,$$MATLABROOT/bin/glnx86
    INCLUDEPATH += "/usr/local/qwt-5.2.1-svn/include" \
        "/usr/include" \
        "/usr/include/dc1394" \
        "/usr/local/include/opencv" \
        "/usr/local/include" \
        "$$MATLABROOT/extern/include"
}
QT += opengl \
    svg
SOURCES += main.cpp \
    mainwindow.cpp \
    videoframe.cpp \
    imageprocessing.cpp \
    calibrationdialog.cpp \
    positionestimator.cpp \
    tracker.cpp \
    videoscene.cpp \
    plot.cpp \
    videofile.cpp \
    videosource.cpp \
    image.cpp \
    vesselsearch.cpp \
    videographicsitem.cpp \
    trackingmanager.cpp \
    videodisplay.cpp \
    cameramanager.cpp \
    videocamera.cpp \
    cameracontrols.cpp \
    camera.cpp \
    presentation.cpp \
    wavemap.cpp \
    waveestimator.cpp \
    mapselector.cpp \
    framewriter.cpp \
    sourceselector.cpp \
    houghsvg.cpp \
    util.cpp \
    parameters.cpp \
    export.cpp \
    glwidget.cpp
unix:SOURCES += sys1394.cpp \
    video1394.cpp
HEADERS += mainwindow.h \
    videoframe.h \
    imageprocessing.h \
    calibrationdialog.h \
    positionestimator.h \
    tracker.h \
    videoscene.h \
    plot.h \
    videofile.h \
    videosource.h \
    image.h \
    vesselsearch.h \
    videographicsitem.h \
    trackingmanager.h \
    videodisplay.h \
    cameramanager.h \
    videocamera.h \
    cameracontrols.h \
    presentation.h \
    camera.h \
    wavemap.h \
    waveestimator.h \
    mapselector.h \
    framewriter.h \
    sourceselector.h \
    houghsvg.h \
    util.h \
    parameters.h \
    export.h \
    glext.h \
    glwidget.h
unix:HEADERS += sys1394.h \
    video1394.h
FORMS += mainwindow.ui \
    calibrationdialog.ui \
    plot.ui \
    cameracontrols.ui \
    presentation.ui \
    sourceselector.ui \
    parameters.ui
