#ifndef CAMERA_H
#define CAMERA_H

#include <QThread>
#include <QImage>
#include <vector>
#include <cv.h>
#include <highgui.h>

#include "videosource.h"

class VideoCamera : public VideoSource
{

private:
   unsigned int id;
   CvCapture * capture;
   QImage * image;

public:
    VideoCamera(QString);
    ~VideoCamera();
    bool init();
    bool captureFrame();
    IplImage * getFrame();
    void close();
    QSize getVideoSize();
};



#endif // CAMERA_H

